create or replace
PROCEDURE ETL_INDICADORES_IMPLANTA (P_DTINICIAL IN DATE,
                                        P_DTFINAL   IN DATE)
IS
   V_ANOINIC      VARCHAR2(4);
   V_PERIODO      VARCHAR2(19);
   V_DTINT        DATE;
   V_MESINIC      VARCHAR2(2);
   V_FATURADAS    VARCHAR2(10);
   V_DTINICIAL    DATE;
   V_DTFINAL      DATE;
   V_COUNTINIC    VARCHAR2(2) NOT NULL := '21';
   V_COUNTFIM     VARCHAR2(2) NOT NULL := '20';
   V_CONTFAT      FLOAT NOT NULL := 0;
   V_CONTSEM      FLOAT NOT NULL := 0;
   V_CDFUNC       VARCHAR2(10) NOT NULL := 0;
   V_CDCLIENTE    VARCHAR2(21) NOT NULL := 0;
   V_DTANO           VARCHAR2(04);
   V_NMCONTACTADO    VARCHAR2(50);
   V_IDSTATUSCONT    VARCHAR2(12);
   V_TIPOCONTATADO   VARCHAR2(10);

  /*CONSTANTES*/

  CON_CONCLUIDO     VARCHAR2(9)  := 'Concludo';
  CON_ANDAMENTO     VARCHAR2(12) := 'Em Andamento';
  CON_PROSPECT      VARCHAR2(08) := 'Prospect';
  CON_CLIENTE       VARCHAR2(07) := 'Cliente';
  CON_FORNECEDOR    VARCHAR2(10) := 'Fornecedor';
  CON_VENDEDOR      VARCHAR2(08) := 'Vendedor';


BEGIN

   V_MESINIC := TO_CHAR(P_DTINICIAL,'DD');
   V_DTINICIAL := TO_DATE(V_COUNTINIC||TO_CHAR(P_DTINICIAL, 'MMYYYY'), 'DDMMYYYY');
   V_DTFINAL := TO_DATE(V_COUNTFIM||TO_CHAR(P_DTFINAL, 'MMYYYY'), 'DDMMYYYY');

   IF V_MESINIC < V_COUNTINIC THEN
      V_DTINICIAL := ADD_MONTHS(V_DTINICIAL,-1);
   END IF;

/*APAGA OS DADOS J EXISTENTES A PARTIR DA DATA INCIO DA TABELA ETLINDTEKIMP*/
   DELETE FROM ETLINDTEKIMP
   WHERE DTINICIOIMP >= V_DTINICIAL;

/*APAGA OS DADOS J EXISTENTES A PARTIR DA DATA INCIO DA TABELA ETLINDTEKCONT*/
   DELETE FROM ETLINDTEKCONT
   WHERE DTINICIOCONT >= V_DTINICIAL;


   V_DTINT := V_DTINICIAL - 1;

WHILE (V_DTINT  <=  V_DTFINAL) LOOP

    FOR C_ETL IN
      (
        SELECT     S.CDCLIENTE, F.CDEMPRESA, F.CDFUNC, T.CDTIPOSERV, CO.VRDEHORACONT,
                   ((NVL(SUM(DTHRSAID2FAT - DTHRENTR2FAT),0)*24) + (NVL(SUM(DTHRSAID1FAT - DTHRENTR1FAT),0)*24))*60 AS FATURADAS,

                   ((CO.VRDEHORACONT * ((NVL(SUM(DTHRSAID2FAT - DTHRENTR2FAT),0)*24) + (NVL(SUM(DTHRSAID1FAT - DTHRENTR1FAT),0)*24)))/50) * 60 AS FATURADAS50 ,

                   (((NVL(SUM(DTHRSAID2TUR - DTHRENTR2TUR),0)*24) + (NVL(SUM(DTHRSAID1TUR - DTHRENTR1TUR),0)*24)) - ((NVL(SUM(DTHRSAID2FAT - DTHRENTR2FAT),0)*24) + (NVL(SUM(DTHRSAID1FAT - DTHRENTR1FAT),0)*24)))*60 AS SEMCUSTO,

                   ((NVL(SUM(DTHRSAID2TUR - DTHRENTR2TUR),0)*24) + (NVL(SUM(DTHRSAID1TUR - DTHRENTR1TUR),0)*24))*60 AS TRABALHADAS

            FROM    SERVPREST S, CLIENTE C, FUNCIONARIO F, PARCLIEFAS PA, ENDECLIE E, TIPOSERV T, CONTRATOSERV CO
           WHERE    S.DTSERVPREST BETWEEN  V_DTINICIAL AND V_DTINT
             AND    S.CDCLIENTE = C.CDCLIENTE
             AND    S.CDFUNC = F.CDFUNC
             AND    S.CDEMPRESA = F.CDEMPRESA
             AND    PA.CDCLIENTE = S.CDCLIENTE
             AND    C.CDCLIENTE = E.CDCLIENTE
             AND    E.IDTPENDECLIE = 'P'
             AND    C.CDCLIENTE NOT IN ('J26269316000177')
             AND    S.CDTIPOSERV = T.CDTIPOSERV
             AND    S.CDCLIENTE = CO.CDCLIENTE
             AND    S.CDTIPOSERV = CO.CDTIPOSERV
             AND    S.NRPROPOSFAS =  CO.NRPROPOSFAS
             AND    S.NRSERVCONT = CO.NRSERVCONT
        GROUP BY    S.CDCLIENTE, T.CDTIPOSERV, F.CDFUNC, CO.VRDEHORACONT, F.CDEMPRESA
        ORDER BY    S.CDCLIENTE, F.CDFUNC
   )   LOOP

           V_PERIODO := TO_CHAR(V_DTINICIAL||' - '||V_DTINT);
           V_ANOINIC := TO_CHAR(V_DTINT, 'YYYY');

             IF  C_ETL.FATURADAS > 0 THEN
                 V_FATURADAS := 'FATURADO';
              ELSE
                 V_FATURADAS := 'SEM CUSTO';
           END IF;

           IF    C_ETL.CDCLIENTE = V_CDCLIENTE AND C_ETL.CDFUNC = V_CDFUNC THEN
                 V_CONTSEM := 0;
                 V_CONTFAT := 0;
           ELSE
               IF  C_ETL.FATURADAS > 0 THEN
                   V_CONTFAT := 1;
               ELSE
                   V_CONTSEM := 1;
               END IF;
          END IF;
        /*INSERIR DADOS NA TABELA */
            INSERT INTO ETLINDTEKIMP
                  (
                    CDTIPOSERV,      CDEMPRESA,     CDFUNC,      CDCLIENTE,
                    CDANOBI,         DSPERAPUSERIMP,  NRHRTRABOPTEKIM,
                    NRHRFATOPTEKIM,  NRHRSEMCUSOPIMP, NRHRFATUOPIMP,
                    TPCOLABORADOR,   DTINICIOIMP,     NRCOLHRFAT,
                    NRCOLHRSEM

                  )

            VALUES
                  (
                   C_ETL.CDTIPOSERV,     C_ETL.CDEMPRESA,  C_ETL.CDFUNC,    C_ETL.CDCLIENTE,
                    V_ANOINIC,           V_PERIODO,       C_ETL.TRABALHADAS,
                    C_ETL.FATURADAS,     C_ETL.SEMCUSTO,  C_ETL.FATURADAS50,
                    V_FATURADAS,         V_DTINICIAL,     V_CONTFAT,
                    V_CONTSEM
                  );
            COMMIT;

            V_CDFUNC := C_ETL.CDFUNC;
            V_CDCLIENTE := C_ETL.CDCLIENTE;
            V_CONTFAT := 0;
            V_CONTSEM := 0;

   END LOOP;

   FOR C_ETLCONT IN
             (
              SELECT   COUNT(CON.CDFILIAL||CON.NRCONTATO||EVO.NRSEQEVOLCON) AS QTCONTATOS, CON.CDFILIAL,
                       CON.CDMOTICONT, CON.DTHRCONTATO, CON.IDSTATUSCONT, CON.CDCLIENTE,
                       CON.CDFORNECED, CON.CDPROSPECT, CON.CDVENDEDOR, CON.IDTPCONTATO,
                       CON.CDSISTEMA, CON.CDOPCONCCONT, CON.IDCONTAPROV, EVO.CDOPEREVOL,
                       EVO.CDMOTIEVOCON, SIS.CDPROCOMERCI, TPC.CDTIPOCONT

                  FROM CONTATO CON, EVOLCONT EVO, SISTEMA SIS, TIPOCONT TPC
                 WHERE (trunc(EVO.DtHrEvolCont)  BETWEEN V_DTINICIAL AND V_DTINT)
                   AND (EVO.CDFILIAL (+) = CON.CDFILIAL)
                   AND (EVO.NRCONTATO(+) = CON.NRCONTATO)
                   AND (SIS.CDSISTEMA(+) = CON.CDSISTEMA)
                   AND TPC.CDTIPOCONT(+) = EVO.CDTIPOCONT
              GROUP BY
                    CON.CDFILIAL,    CON.CDMOTICONT,   CON.DTHRCONTATO,  CON.IDSTATUSCONT,
                    CON.CDCLIENTE,   CON.CDFORNECED,   CON.CDPROSPECT,   CON.CDVENDEDOR,
                    CON.IDTPCONTATO, CON.CDSISTEMA,    CON.CDOPCONCCONT, CON.IDCONTAPROV,
                    EVO.CDOPEREVOL,  EVO.CDMOTIEVOCON, SIS.CDPROCOMERCI, TPC.CDTIPOCONT

              )  LOOP
/* IDENTIFICA O STATUS EM ANDAMENTO E CONCLUDO*/
         --  V_PERIODO := TO_CHAR(V_DTINICIAL||' - '||V_DTINT);
   --        V_ANOINIC := TO_CHAR(V_DTINT, 'YYYY');

              IF   C_ETLCONT.IDSTATUSCONT = 'C' THEN
                   V_IDSTATUSCONT := CON_CONCLUIDO;
                ELSE
                   V_IDSTATUSCONT := CON_ANDAMENTO;
              END IF;
/* IDENTIFICA O TIPO DO CONTATO (COM CLIENTE/ PROSPECT /VENDEDOR OU FORNECEDOR)*/
              IF C_ETLCONT.IDTPCONTATO = 'C'    THEN
                 V_TIPOCONTATADO  := CON_CLIENTE;
                 BEGIN
                      SELECT NMFANTCLIE
                        INTO V_NMCONTACTADO
                        FROM CLIENTE
                       WHERE CDCLIENTE = C_ETLCONT.CDCLIENTE ;
                   EXCEPTION
                   WHEN OTHERS THEN
                     V_NMCONTACTADO :=NULL;
                 END;
                ELSIF C_ETLCONT.IDTPCONTATO='P' THEN
                      V_TIPOCONTATADO  := CON_PROSPECT;
                      BEGIN
                          SELECT NMFANTPROS
                            INTO V_NMCONTACTADO
                            FROM PROSPECT
                           WHERE (CDPROSPECT = C_ETLCONT.CDPROSPECT)  ;
                       EXCEPTION
                       WHEN OTHERS THEN
                          V_NMCONTACTADO := NULL;
                      END;
                ELSIF C_ETLCONT.IDTPCONTATO='F' THEN
                      V_TIPOCONTATADO  := CON_FORNECEDOR;
                      BEGIN
                          SELECT NMFANTFORN
                            INTO V_NMCONTACTADO
                            FROM FORNECEDOR
                           WHERE (CDFORNECED = C_ETLCONT.CDFORNECED) ;
                       EXCEPTION
                       WHEN OTHERS THEN
                          V_NMCONTACTADO := NULL;
                      END;
                ELSIF C_ETLCONT.IDTPCONTATO='V' THEN
                      V_TIPOCONTATADO  := CON_VENDEDOR;
                      BEGIN
                          SELECT NMFANVEN
                            INTO V_NMCONTACTADO
                            FROM VENDEDOR
                           WHERE CDVENDEDOR = C_ETLCONT.CDVENDEDOR;
                       EXCEPTION
                       WHEN OTHERS THEN
                          V_NMCONTACTADO := NULL;
                      END;
              END IF;
/*INSERIR DADOS NA TABELA ETLINDTEKCONT*/
             INSERT INTO ETLINDTEKCONT
                ( CDFILIAL,        CDTIPOCONT,   CDMOTIEVOCON,
                  CDSISTEMA,       CDANOBI,      DSCONTTEKCONT,
                  DSPERAPUSERCONT, STATUSEVOCON, TPEVOCON,
                  QTCONTREAEVOCON, DTINICIOCONT)
              VALUES
                (C_ETLCONT.CDFILIAL,     C_ETLCONT.CDTIPOCONT,  C_ETLCONT.CDMOTIEVOCON,
                 C_ETLCONT.CDSISTEMA,    V_ANOINIC,               V_NMCONTACTADO,
                 V_PERIODO,              V_IDSTATUSCONT,        V_TIPOCONTATADO,
                 C_ETLCONT.QTCONTATOS,   V_DTINICIAL);
             COMMIT;
       END LOOP;
   V_DTINICIAL := V_DTINT + 1;
   V_DTINT := ADD_MONTHS(V_DTINT,1);
   END LOOP;
END;